<template>
    <video-player  class="video-player-box"
                   ref="videoPlayer"
                   :options="playerOptions"
                   :playsinline="true"
                   customEventName="customstatechangedeventname"

                   @canplaythrough="onPlayerCanplaythrough($event)"

                   @statechanged="playerStateChanged($event)"
                   @ready="playerReadied">
    </video-player>
</template>

<script>
    import 'video.js/dist/video-js.css'

    import { videoPlayer } from 'vue-video-player'

    // videojs
    import videojs from 'video.js'
    window.videojs = videojs
    // hls plugin for videojs6
    require('videojs-contrib-hls/dist/videojs-contrib-hls.js')
    require('videojs-contrib-quality-levels')

    export default {
        name: "player",
        components: {
            videoPlayer
        },
        data() {
            return {
                playerOptions: {
                    // videojs and plugin options
                    autoplay: true,
                    muted: true,
                    language: 'ru',
                    responsive: true,
                    sources: [{
                        withCredentials: false,
                        type: "application/x-mpegURL",
                        src: "http://s3.tvcompany.com/TV1000_Action/index.m3u8"
                    }],
                    controlBar: {
                        timeDivider: false,
                        durationDisplay: false,
                        qualityLevels: true
                    },
                    flash: { hls: { withCredentials: false }},
                    html5: { hls: { withCredentials: false }},
                    poster: "/images/logo.png"
                }
            }
        },
        mounted() {
            console.log('this is current player instance object', this.player)
        },
        computed: {
            player() {
                return this.$refs.videoPlayer.player
            }
        },
        methods: {
            // listen event
            onPlayerPlay(player) {
                // console.log('player play!', player)
            },
            onPlayerPause(player) {
                // console.log('player pause!', player)
            },
            // ...player event

            onPlayerCanplaythrough(event) {
                console.log(event)
            },

            // or listen state event
            playerStateChanged(playerCurrentState) {
                // console.log('player current update state', playerCurrentState)
            },

            playerReadied(player) {
                var hls = player.tech({ IWillNotUseThisInPlugins: true }).hls;

                var qualityLevels = player.qualityLevels();
                for (var i = 0; i < qualityLevels.length; i++) {
                    var quality = qualityLevels[i];
                    if (quality.width >= 720) {
                        quality.enabled = true;
                    } else {
                        quality.enabled = false;
                    }
                }

                player.tech_.hls.xhr.beforeRequest = function(options) {
                    return options
                }
            },
        }
    }
</script>

<style >
    .video-js {
        width: 100% !important;
        height: calc( (100vw - 150px)*9 /16) !important;
        max-height: calc(100vh - 230px);
    }
    .vjs-poster {
        background-color: #478dcd !important;
        background-size: 250px !important;
    }

    @media (max-width: 600px) {
        .video-js {
            height: calc( (100vw - 50px)*9 /16) !important;
        }
    }
</style>
